/*
 *	ff6rndtbl.c
 *		Copyright (C)2001 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>

#define NUM_RANDOM			65536	/* ̎ */
#define NUM_RANDOM_TBL		256		/* \̗vf */

#define get_rnd(index)		((tbl_rnd[((index) % NUM_RANDOM_TBL)] + ((index) / 256) * 23) % 256)

static int make_enctbl(const char *ptr_filename, int elem_num, int (*monenc)(int num));
static int make_rndtbl(const char *ptr_filename, int elem_num);

static int monenc_n(int num);
static int monenc_f(int num);
static int monenc_b(int num);

/* t@Cit@^W[VI̗\ */
static const int tbl_rnd[NUM_RANDOM_TBL] =
{
	0x07, 0xb6, 0xf0, 0x1f, 0x55, 0x5b, 0x37, 0xe3, 0xae, 0x4f, 0xb2, 0x5e, 0x99, 0xf6, 0x77, 0xcb,
	0x60, 0x8f, 0x43, 0x3e, 0xa7, 0x4c, 0x2d, 0x88, 0xc7, 0x68, 0xd7, 0xd1, 0xc2, 0xf2, 0xc1, 0xdd,
	0xaa, 0x93, 0x16, 0xf7, 0x26, 0x04, 0x36, 0xa1, 0x46, 0x4e, 0x56, 0xbe, 0x6c, 0x6e, 0x80, 0xd5,
	0xb5, 0x8e, 0xa4, 0x9e, 0xe7, 0xca, 0xce, 0x21, 0xff, 0x0f, 0xd4, 0x8c, 0xe6, 0xd3, 0x98, 0x47,
	0xf4, 0x0d, 0x15, 0xed, 0xc4, 0xe4, 0x35, 0x78, 0xba, 0xda, 0x27, 0x61, 0xab, 0xb9, 0xc3, 0x7d,
	0x85, 0xfc, 0x95, 0x6b, 0x30, 0xad, 0x86, 0x00, 0x8d, 0xcd, 0x7e, 0x9f, 0xe5, 0xef, 0xdb, 0x59,
	0xeb, 0x05, 0x14, 0xc9, 0x24, 0x2c, 0xa0, 0x3c, 0x44, 0x69, 0x40, 0x71, 0x64, 0x3a, 0x74, 0x7c,
	0x84, 0x13, 0x94, 0x9c, 0x96, 0xac, 0xb4, 0xbc, 0x03, 0xde, 0x54, 0xdc, 0xc5, 0xd8, 0x0c, 0xb7,
	0x25, 0x0b, 0x01, 0x1c, 0x23, 0x2b, 0x33, 0x3b, 0x97, 0x1b, 0x62, 0x2f, 0xb0, 0xe0, 0x73, 0xcc,
	0x02, 0x4a, 0xfe, 0x9b, 0xa3, 0x6d, 0x19, 0x38, 0x75, 0xbd, 0x66, 0x87, 0x3f, 0xaf, 0xf3, 0xfb,
	0x83, 0x0a, 0x12, 0x1a, 0x22, 0x53, 0x90, 0xcf, 0x7a, 0x8b, 0x52, 0x5a, 0x49, 0x6a, 0x72, 0x28,
	0x58, 0x8a, 0xbf, 0x0e, 0x06, 0xa2, 0xfd, 0xfa, 0x41, 0x65, 0xd2, 0x4d, 0xe2, 0x5c, 0x1d, 0x45,
	0x1e, 0x09, 0x11, 0xb3, 0x5f, 0x29, 0x79, 0x39, 0x2e, 0x2a, 0x51, 0xd9, 0x5d, 0xa6, 0xea, 0x31,
	0x81, 0x89, 0x10, 0x67, 0xf5, 0xa9, 0x42, 0x82, 0x70, 0x9d, 0x92, 0x57, 0xe1, 0x3d, 0xf1, 0xf9,
	0xee, 0x08, 0x91, 0x18, 0x20, 0xb1, 0xa5, 0xbb, 0xc6, 0x48, 0x50, 0x9a, 0xd6, 0x7f, 0x7b, 0xe9,
	0x76, 0xdf, 0x32, 0x6f, 0x34, 0xa8, 0xd0, 0xb8, 0x63, 0xc8, 0xc0, 0xec, 0x4b, 0xe8, 0x17, 0xf8,
};

/* 쌠\L */
static const char *str_copyright = "ff6rndtbl - Copyright (C)2001 Shingo Endo <s-endo@yk.rim.or.jp>";

int main(void)
{
	make_enctbl("ff6monenctbl_n.txt", NUM_RANDOM, monenc_n);
	make_enctbl("ff6monenctbl_f.txt", NUM_RANDOM, monenc_f);
	make_enctbl("ff6monenctbl_b.txt", NUM_RANDOM / 32, monenc_b);

	make_rndtbl("ff6monencrndtbl.txt", NUM_RANDOM);

	return 0;
}

static int make_enctbl(const char *ptr_filename, int elem_num, int (*monenc)(int num))
{
	int i, index;
	FILE *fp = NULL;

	if (ptr_filename == NULL || *ptr_filename == '\0')
		return 0;

	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	for (index = 0; index < elem_num; index++)
	{
		/* wb_̏o */
		if (index % 256 == 0)
		{
			fprintf(fp, "     ");
			for (i = 0; i < 16; i++)
				fprintf(fp, " %1X", i);
			fprintf(fp, "\n");
			fprintf(fp, "-------------------------------------\n");
		}

		/* swb_̏o */
		if (index % 16 == 0)
			fprintf(fp, "%04X:", index);

		/* vf̏o */
		fprintf(fp, " %c", "ABCDEFGH"[monenc(get_rnd(index))]);

		/* s̏o */
		if ((index + 1) % 16 == 0)
			fprintf(fp, "\n");	
		if ((index + 1) % 256 == 0)
			fprintf(fp, "\n");
	}

	fclose(fp);
}

static int make_rndtbl(const char *ptr_filename, int elem_num)
{
	int i, index;
	FILE *fp = NULL;

	if (ptr_filename == NULL || *ptr_filename == '\0')
		return 0;

	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	for (index = 0; index < elem_num; index++)
	{
		/* wb_̏o */
		if (index % 256 == 0)
		{
			fprintf(fp, "     ");
			for (i = 0; i < 16; i++)
				fprintf(fp, "  %1X", i);
			fprintf(fp, "\n");
			fprintf(fp, "-----------------------------------------------------\n");
		}

		/* swb_̏o */
		if (index % 16 == 0)
			fprintf(fp, "%04X:", index);

		/* vf̏o */
		fprintf(fp, " %02X", get_rnd(index));

		/* s̏o */
		if ((index + 1) % 16 == 0)
			fprintf(fp, "\n");	
		if ((index + 1) % 256 == 0)
			fprintf(fp, "\n");
	}

	fclose(fp);
}

static int monenc_n(int num)
{
	if (0x00 <= num && num < 0x50)
		return 0;
	else if (0x50 <= num && num < 0xa0)
		return 1;
	else if (0xa0 <= num && num < 0xf0)
		return 2;
	else
		return 3;
}

static int monenc_f(int num)
{
	if (0x00 <= num && num < 0xc0)
		return 0;
	else
		return 1;
}

static int monenc_b(int num)
{
	return num % 8;
}
